// Copyright 2008 Brian Caine

// This file is part of Potpourri.

// Potpourri is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Potpourri is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTIBILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Potpourri. If not, see <http://www.gnu.org/licenses/>.


// NOTES:
// Autogenerated header

#ifndef __PARSEGAME_H
#define __PARSEGAME_H

#include <libxml++/libxml++.h>

#include "XmlExtra.h"
#include <string>

namespace XMLParser
{  
  namespace parsegame
    {
      struct meta
        {
          std::string m_title;
          std::string m_version;
          std::vector<std::string> m_author;
          std::string m_about;
          std::string m_icon;
        };

      struct graphics
        {
          int m_width;
          int m_height;
        };

      struct presentation
        {
          std::string m_name;
          graphics m_graphics;
          bool m_net;
        };

      struct event
        {
          std::string m_name;
          std::string m_default;
        };

      struct controls
        {
          std::vector<event> m_event;
        };

      struct plugins
        {
          std::string m_graphics;
          std::string m_input;
          std::string m_audio;
          std::string m_script;
          std::vector<std::string> m_extra;
        };

      struct dgraphics
        {
          std::string m_name;
          std::string m_plugin;
          std::string m_filename;
        };

      struct audio
        {
          std::string m_name;
          std::string m_filename;
        };

      struct media
        {
          std::vector<dgraphics> m_graphics;
          std::vector<audio> m_audio;
        };

      struct game
        {
          meta m_meta;
          std::vector<presentation> m_presentation;
          controls m_controls;
          plugins m_plugins;
          media m_media;
          std::vector<std::string> m_actor;
          std::vector<std::string> m_level;
        };

      game parsegameFromBuffer(std::string);

      controls parsecontrolsFromBuffer(std::string);
      std::map<std::string, std::string> controlsTomap(controls);

      game parsegame(xmlpp::Node*);
      std::string parsename(xmlpp::Node*);
      audio parseaudio(xmlpp::Node*);
      std::string parseplugin(xmlpp::Node*);
      std::string parsefilename(xmlpp::Node*);
      graphics parsegraphics(xmlpp::Node*);
      dgraphics parsedgraphics(xmlpp::Node*);
      audio parseaudio(xmlpp::Node*);
      media parsemedia(xmlpp::Node*);
      std::string parsegraphicsplugin(xmlpp::Node*);
      std::string parseinput(xmlpp::Node*);
      std::string parseaudioplugin(xmlpp::Node*);
      std::string parsescript(xmlpp::Node*);
      std::string parseextra(xmlpp::Node*);
      plugins parseplugins(xmlpp::Node*);
      std::string parsedefault(xmlpp::Node*);
      event parseevent(xmlpp::Node*);
      event parseevent(xmlpp::Node*);
      controls parsecontrols(xmlpp::Node*);
      int parsewidth(xmlpp::Node*);
      int parseheight(xmlpp::Node*);
      std::string parsename(xmlpp::Node*);
      bool parsenet(xmlpp::Node*);
      presentation parsepresentation(xmlpp::Node*);
      std::string parsetitle(xmlpp::Node*);
      std::string parseversion(xmlpp::Node*);
      std::string parseauthor(xmlpp::Node*);
      std::string parseabout(xmlpp::Node*);
      std::string parseicon(xmlpp::Node*);
      meta parsemeta(xmlpp::Node*);
      std::string parseactor(xmlpp::Node*);
      std::string parselevel(xmlpp::Node*);
    }
}

#endif
